<!-- 出库单列表 -->
<template>
    <div class="table-box">
        <!-- 按钮 -->
        <ListBtns :selectionList="selectionList" @handleParentCallback="handleParentCallback" :ruleForm="datas.exportList" />
        <Search
            :formData="datas.formData"
            :ruleForm="datas.ruleForm"
            @handleSearch="handleSearch"
            @handleReset="handleReset"
            @handleRemoteMehod="handleRemoteMehod"
        />
        <!-- 表格 -->
        <ProTable
            ref="proTable"
            :columns="datas.columns"
            :request-api="getOutStockListApi"
            :init-param="datas.initParam"
            :ruleForm="datas.ruleForm"
            @selectionChange="selectionChange"
        >
            <!-- 点击跳转到详情去 -->
            <template #billNo="scope">
                <a @click="handleToDetail(scope.row)" class="break-word to-details">
                    {{ scope.row.billNo }}
                </a>
            </template>

            <!-- successSync -->
            <template #successSync="scope">
                <a
                    @click="handleSuccessSync(scope.row)"
                    :class="scope.row.successSync == '失败' && scope.row.type == '销售出库' ? 'break-word to-detail1' : ''"
                >
                    {{ scope.row.type == "销售出库" ? scope.row.successSync : "--" }}
                </a>
            </template>
        </ProTable>
    </div>
</template>

<script setup lang="ts" name="outboundOrderList">
import ListBtns from "@/components/ListBtns/index.vue";
import Search from "@/components/Search/index.vue";
import ProTable from "@/components/ProTable/index.vue";
import { cloneDeep } from "lodash-es";
import { RULEFORM, FORMDATA, COLUMNS } from "./constant/list/index";
import { getOutStockListApi } from "@/api/modules/deliveryAndOutbound";
import { initSearch } from "./init/index";
import { useSetSearchData, useSearchInfoArray } from "@/hooks/useSearch";
import { useRouter } from "vue-router";
import { ElMessageBox } from "element-plus";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const proTable = ref<any>(null);
const $router = useRouter();
// 数据源
const datas = reactive({
    exportList: cloneDeep(RULEFORM),
    columns: COLUMNS, //列表配置项
    initParam: cloneDeep(RULEFORM), // 初始化搜索条件|重置搜索条件
    ruleForm: cloneDeep(RULEFORM), // 搜索条件
    formData: FORMDATA //搜索配置项
});
//选中表格的行
let selectionList = ref([]);
initSearch(datas);
/**
 *
 * @description 获取按钮操作结果
 * @param type {string} 按钮类型
 * @param result {Object} 操作结果
 */
//result?: Record<string, any>
const handleParentCallback = () => {
    datas.ruleForm = cloneDeep(RULEFORM);
    proTable!.value.getTableList(datas.initParam);
};
const handleSearch = () => {
    proTable!.value.initPage(datas.ruleForm);
    datas.exportList = datas.ruleForm;
    datas.exportList.pageNo = proTable!.value.pageable.pageNo;
    datas.exportList.pageSize = proTable!.value.pageable.pageSize;
};
const handleSuccessSync = (row: any) => {
    if (row.successSync === "失败") {
        ElMessageBox.alert(row.remark, "失败原因", {
            confirmButtonText: "确认",
            callback: (action: any) => {
                console.log(action);
            }
        });
    }
};
const handleReset = () => {
    datas.ruleForm = cloneDeep(RULEFORM);
    datas.exportList = cloneDeep(RULEFORM);
    proTable!.value.initPage(datas.initParam);
};
const selectionChange = (selection: any) => {
    selectionList.value = selection;
};
const handleRemoteMehod = (params: any) => {
    const { data, prop } = params;
    if (prop === "receiptCustomer") {
        datas.formData = useSetSearchData(datas.formData, {
            receiptCustomer: useSearchInfoArray(data)
        });
    }
    if (prop === "supplierId") {
        datas.formData = useSetSearchData(datas.formData, {
            supplierId: useSearchInfoArray(data)
        });
    }
    if (prop === "deliveryOrgId") {
        datas.formData = useSetSearchData(datas.formData, {
            deliveryOrgId: useSearchInfoArray(data)
        });
    }
};

//跳转到详情
const handleToDetail = (row: any) => {
    $router.push({
        path: "/deliveryAndOutbound/outboundOrderList/details",
        query: {
            id: row.id
        }
    });
};
</script>

<style scoped>
.to-details {
    color: #4178d5;
    cursor: pointer;
}
.to-detail1 {
    color: red;
    cursor: pointer;
}
</style>
